(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: PATVOR2.PAS                                                    *)
(*  Obsah: program pro tvorbu a editaci barevnych palet (256 barev)        *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 30.10.2020                                            *)
(*  Pro kompilaci: viz Uses                                                *)
(*  Pro spusteni: EN_STD.RK, MSDFLT.FNT, STDSIPKA.KUR, W4TXTCZ.DAT         *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program PAletoTVORic_Mk_2;
{$I-}
uses vesa2,paleta2,klavesy2,errmsg,grafika4,retezce,woknows4,mys4,cfg,disk;

var r,g,b,{slozky vybrane barvy}
    barva,{vybrana barva}
    barva1,{pomocna}
    jas:byte;{jas cele palety (projevuje se jen na obrazovce, do souboru se neulozi)}
    o:word;{pro klavesnici}
    pal:rgbpal256;{paleta}
    soubor:string[79];{jmeno souboru}
    cernoz:zatrzitko;
    SeznamVymen:array[0..255] of byte;
    PocetVymen:word;

const JmenoVymen:string[30]='PTVYMENY.PAS'; {jmeno souboru, do ktereho se maji vymeny ulozit}

procedure VymazSeznamVymen;
var b:byte;
Begin
for b:=0 to 255 do seznamvymen[b]:=b;
pocetvymen:=0;
End;{vymazseznamvymen}

procedure VymenBarvy(Jedna,Druha:byte; INaObrazovce:boolean);
{Prohodi dve barvy v palete, zapamatuje si to v poli SeznamVymen
a pri INaObrazovce=true aplikuje zmenu i na obrazovku.}
var pom,i:byte;
Begin
for i:=1 to 3 do begin
                 pom:=pal[jedna,i];
                 pal[jedna,i]:=pal[druha,i];
                 pal[druha,i]:=pom;
                 end;
if inaobrazovce then nastavpaletu(pal,0,255,jas);
pom:=jedna;
seznamvymen[jedna]:=druha;
seznamvymen[druha]:=pom;
inc(pocetvymen);
End;{vymenbarvy}

procedure UlozVymeny;
{ulozi seznam vymen barev do souboru; komplet vcetne zadani jmena}
var f:text;
    i:byte;
    jmeno2:string[79];
Begin
 repeat
 jmeno2:=vybersouborokno('Soubor pro vpis',jmenovymen,'*.*',true);
 until (jmeno2='') {zruseno}
       or not existujesoubor(jmeno2)
       or anoneokno('Soubor '+jmeno2+' u existuje.|Chcete ho pepsat?');
if jmeno2='' then exit;
jmenovymen:=jmeno2;
assign(f,jmenovymen);
rewrite(f);
if ioresult<>0 then okokno('%%nChyba!%%NSoubor '+jmenovymen+' nejde otevt pro zpis.');
writeln(f,'{seznam vymen barev v palete ',soubor,'}');
write(f,'const SeznamVymen:array[0..255] of byte=(');
for i:=0 to 254 do write(f,seznamvymen[i],',');
writeln(f,seznamvymen[255],');');
writeln(f,'{pouziti:');
writeln(f,'for (kazdy pixel obrazku) do pixel:=seznamvymen[pixel]; }');
close(f);
if ioresult<>0 then okokno('Pi ukldn do souboru '+jmenovymen+' dolo k chyb,|mon nen uloen cel.');
End;{ulozvymeny}

procedure load;{nacteni ze souboru}
var f:file of rgbpal256;
Begin
if soubor='' then soubor:=vybersouborokno('Paleta k naten',soubor,'*.PAL',false);
if soubor='' then exit;
assign(f,soubor);
reset(f);
read(f,pal);
close(f);
if ioresult=0 then begin
                   nastavpaletu(pal,0,255,jas);
                   vymazseznamvymen;
                   end
              else okokno('%%nChyba%%NSoubor '+soubor+' neexistuje nebo neel pest.');
End;{load}

procedure save;{ulozeni do souboru}
var f:file of rgbpal256;
Begin
if soubor='' then soubor:=vybersouborokno('Kam uloit?',soubor,'*.PAL',true);
if soubor='' then exit;
assign(f,soubor);
rewrite(f);
write(f,pal);
close(f);
if ioresult<>0 then okokno('Chyba pi ukldn do souboru '+soubor);
End;{save}

procedure zmen(slozka,hodnota:byte);
{zmena dane slozky vybrane barvy na danou hodnotu}
Begin
case slozka of 1:r:=hodnota;
               2:g:=hodnota;
               3:b:=hodnota;
               end;
nastavbarvu(pal,barva,r,g,b);
if not cernoz.hodnota then setrgbpal(0,r,g,b);
End;{zmen}

procedure VyberBarvu(NovaBarva:byte);
{barevne - true: v palete vykresli ramecek kolem vybrane barvy,
                 nastavi r,g,b a aplikuje vybranou barvu na pozadi
           false: jenom smaze ramecek v palete}
Begin
kvyp;
{smazani ramecku kolem puvodni vybrane barvy:}
__rectangle((barva and 15)*29,(barva shr 4)*29,
            (barva and 15)*29+29,(barva shr 4)*29+29,0,_outline);
{vyber a aplikace nove barvy:}
barva:=novabarva;
r:=pal[barva,1];
g:=pal[barva,2];
b:=pal[barva,3];
__box((barva and 15)*29,(barva shr 4)*29,
      (barva and 15)*29+29,(barva shr 4)*29+29,14,12,0,_outline);
if not cernoz.hodnota then setrgbpal(0,r,g,b);
End;{vyberbarvu}

procedure PrepniPozadi;
Begin
if cernoz.hodnota then setrgbpal(0,0,0,0) {natvrdo cerna bez ohledu na paletu}
                  else setrgbpal(0,r,g,b);
End;{prepnipozadi}

procedure Gradient(var P:rgbpal256; Vocad,Pocad:byte);
{v palete P v useku Vocad..Pocad vyrobi plynuly prechod mezi dvema krajnimi
barvami}
 function interpol(x1,y1,x2,y2,x:integer):integer;{na primce od x1,y1 do x2,y2 najde bod x,y}
 Begin
 interpol:=y1+((y2-y1)*(x-x1))div(x2-x1);
 End;
var i,j:byte;
Begin
if vocad=pocad then exit;
if vocad>pocad then begin
                    i:=vocad;
                    vocad:=pocad;
                    pocad:=i;
                    end;
for i:=vocad+1 to pocad-1 do
 for j:=1 to 3 do p[i,j]:=interpol(vocad,p[vocad,j],pocad,p[pocad,j],i);
End;{gradient}

procedure NajdiDuplicity;
{prohleda paletu a nahlasi duplicity k aktualne vybrane barve}
var i,pocet:byte;
    zprava:string;
Begin
zprava:=''; pocet:=0;
for i:=0 to 255 do
 if (i<>barva) and (pal[i,1]=pal[barva,1])
    and (pal[i,2]=pal[barva,2]) and (pal[i,3]=pal[barva,3])
   then begin
        inc(pocet);
        zprava:=zprava+' '+nastr(i)+',';
        end;
if zprava='' then okokno('Barva . '+nastr(barva)+' je uniktn.')
             else begin
                  zprava[length(zprava)]:='.';
                  okokno('K barv . '+nastr(barva)+
                         ' existuj tyto duplicity:'+zprava);
                  end;
End;{najdiduplicity}

BEGIN
cfgsoubor:='PATVOR2.CFG';
if nactirozlozeni2('EN_STD.RK')
  then initklav
  else {doufam, ze si uzivatel umi prepnout na anglickou klavesnici};
_setmode(_640x480);
initmys; initwoknows(true,true,true); nactinastavenimysi;
vymazseznamvymen;
for barva:=0 to 255 do begin
                       _bar((barva and 15)*29+1,(barva shr 4)*29+1,(barva and 15)*29+28,(barva shr 4)*29+28,barva);
                       stintext((barva and 15)*29+3,(barva shr 4)*29+11,15,16,1,nastr2(barva,3));
                       end;
{stupnice RGB:}
__box(475,0,584,88,olhbarva,opdbarva,ovbarva,_filled);
__box(479,9,511,74,tplhbarva,tppdbarva,0,_outline);
__box(514,9,515+31,10+64,tplhbarva,tppdbarva,0,_outline);
__box(549,9,550+31,10+64,tplhbarva,tppdbarva,0,_outline);
__print(495,1,16,0,'R   G   B');
{ukazatel jasu:}
__print(597,2,7,0,'Jas:');
__print(625,13,10,0,'%');
{vypis ovladani:}
__print(590,32,7,0,'PgUp:+');
__print(590,42,7,0,'PgDn:-');
__print(590,53,7,0,'N:100%');
__print(495, 95,7,0,'1   2   3 : max ');
__print(495,105,7,0,'Q   W   E :  +1');
__print(495,115,7,0,'A   S   D :  -1');
__print(495,125,7,0,'Z   X   C : min');

__print(475,145,7,0,'Soubor:');
       {475,155}
__print(475,165,7,0,'Enter: zmnit');
__print(475,175,7,0,'F3: nast');
__print(475,185,7,0,'F2: uloit');

__print(475,205,7,0,'Prav mytko:');
__print(480,215,7,0,'vmna barvy s');
__print(480,225,7,0,'aktuln vybranou');
__print(475,235,7,0,'Vmny barev:'); {585,235}
__print(475,245,7,0,'F7: uloit seznam');
__print(475,255,7,0,'F8: smazat seznam');

cernoz.init(475,273,kolikceho(16,' '),'Uruje, jestli bude pozad ern nebo v aktuln upravovan barv.',false);
__print(490,275,7,0,'ern pozad (P)'); {opicarna kvuli vychozi cerne barve textu ve Woknows, kterou jsem liny menit}

__print(475,295,7,0,'G: gradient');
__print(475,305,7,0,'F5: najt duplicity');
__print(475,315,7,0,'M: nastaven myi');
__print(475,325,7,0,'Esc: konec');

{copyright :-) :}
__rectangle(542,451,639,479,9,_outline);
__print(555,456,9,0,'Mircosoft');
__print(548,466,9,0,'PaTvor 2020');
{urceni souboru:}
if paramcount<>0 then soubor:=paramstr(1);
if soubor='' then zjistipaletu(pal)
             else load;
jas:=100; r:=pal[barva,1]; g:=pal[barva,2]; b:=pal[barva,3];
nastavpaletu(pal,0,255,jas); vyberbarvu(0);
resetuj;
 Repeat
 {vykresleni aktualnich hodnot:}
 kvyp;
 kreslisstrafek(480,10,30,63,r,16,4);
 KresliSStrafek(515,10,30,63,g,16,2);
 KresliSStrafek(550,10,30,63,b,16,1);
 _bar(487,77,572,84,ovbarva);
 stintext(487,77,31,16,1,nastr2(r,2));
 stintext(522,77,31,16,1,nastr2(g,2));
 stintext(557,77,31,16,1,nastr2(b,2));
 napis(596,13,10,0,nastr2(jas,3));
 _bar(475,155,639,155+7,0);
 if soubor='' then __print(475,155,12,0,'neuren')
              else __print(475,155,10,0,zkratretezec(soubor,20,0,12));
 napis(585,235,10,0,nastr(pocetvymen)+'    ');
 kzap;
 {vyhodnoceni vstupu od uzivatele:}
 cekej;
 cernoz.kontrola;
 if cernoz.zmeneno then prepnipozadi;
 if keypressed then
  begin
  o:=xreadkey;
  case o of
   xenter:soubor:=vybersouborokno('Vyber paletu',soubor,'*.PAL',false);
   xlsipka:if barva>0 then vyberbarvu(barva-1);
   xpsipka:if barva<255 then vyberbarvu(barva+1);
   xhsipka:if barva shr 4>0 then vyberbarvu(barva-16);
   xdsipka:if barva shr 4<15 then vyberbarvu(barva+16);
   xhome:vyberbarvu(barva and not 15);
   xend:vyberbarvu(barva or 15);
   ord('q'):if r<63 then zmen(1,r+1);
   ord('a'):if r>0 then zmen(1,r-1);
   ord('1'):zmen(1,63);
   ord('z'):zmen(1,0);
   ord('w'):if g<63 then zmen(2,g+1);
   ord('s'):if g>0 then zmen(2,g-1);
   ord('2'):zmen(2,63);
   ord('x'):zmen(2,0);
   ord('e'):if b<63 then zmen(3,b+1);
   ord('d'):if b>0 then zmen(3,b-1);
   ord('3'):zmen(3,63);
   ord('c'):zmen(3,0);
   ord('p'):begin
            cernoz.hodnota:=not cernoz.hodnota;
            cernoz.zobraz;
            prepnipozadi;
            end;
   ord('g'):begin {gradient}
            infokno(550,300,'Vyberte druhou|barvu...',false);
            if kliknuto and mysvpoli(0,0,463,463)
              then begin
                   gradient(pal,barva,(ymys div 29)shl 4+(xmys div 29));
                   nastavpaletu(pal,0,255,jas);
                   if not cernoz.hodnota then setrgbpal(0,r,g,b);
                   end;
            resetuj;
            end;
   ord('m'):nastavmysokno(true);
   xf7:ulozvymeny;
   xf8:vymazseznamvymen;
   xf5:najdiduplicity;
   xF2:save;
   xF3:load;
   xpgup:if jas<200 then begin
                         inc(jas);
                         nastavpaletu(pal,0,255,jas);
                         end;
   xpgdn:if jas>0 then begin
                       dec(jas);
                       nastavpaletu(pal,0,255,jas);
                       end;
   ord('n'):begin
            jas:=100;
            nastavpaletu(pal,0,255,jas);
            end;
   end;
  end
 else
  begin {kliknuto}
  if mysvpoli(0,0,463,463)
    then begin
         barva1:=barva;
         vyberbarvu((ymys div 29)shl 4+(xmys div 29));
         if pmys then vymenbarvy(barva,barva1,true);
         end
   else if mysvpoli(480,10,480+30-1,10+63-1) then zmen(1,63-(ymys-10))
    else if mysvpoli(515,10,515+30-1,10+63-1) then zmen(2,63-(ymys-10))
     else if mysvpoli(550,10,550+30-1,10+63-1) then zmen(3,63-(ymys-10))
      else if mysvpoli(542,451,639,479)
             then infokno(xmys,ymys,'http://mircosoft.mzf.cz',false);
  resetuj;
  end;
 Until o=xEsc;
zrusklav;
while zrusrozlozeni do ;
zruswoknows;
_setmode(0);
END.